/**
  *  \file reshack/edit.h
  *  \brief Resource Editor: Editor Base Class
  *
  *  (c) 2001-2011 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_RESHACK_EDIT_H
#define PCC_V2_RESHACK_EDIT_H

#include "cpluslib/object.h"
#include "cpluslib/string.h"

/** Editor base class. */
class RHEditor : public Object {
 public:
    /** Get name of this editor. Displayed in the editor list. */
    virtual string_t getName() = 0;

    /** Edit this item ("Edit" command). */
    virtual void edit() = 0;

    /** Save this item ("Save" command). */
    virtual void save() = 0;

    /** Check for possibly-unsaved changes. */
    virtual bool hasUnsavedChanges() = 0;
};

#endif
