/**
  *  \file ui/widgets/tooltip.h
  *
  *  (c) 2001-2011 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_UI_WIDGETS_TOOLTIP_H
#define PCC_V2_UI_WIDGETS_TOOLTIP_H

#include "ui/ui.h"

class UITooltip : public UIFixedWidget {
    enum {
        FRAME = 4,
        OUT   = 10
    };

    string_t content;
    GfxPoint anchor;
    bool top;

    void computePosition();

 public:
    UITooltip(string_t content, GfxPoint anchor);
    ~UITooltip();

    bool handleEvent(const UIEvent& event, bool second_pass);
    void drawContent(GfxCanvas& can);
};

class UITooltipControl {
    UIBaseWidget& b;
    bool      mouse_inside;
    GfxPoint  mouse_pos;
    int       mouse_counter;
 public:
    UITooltipControl(UIBaseWidget& b);
    bool checkEvent(const UIEvent& event);
    void checkState();
    GfxPoint getTooltipPosition() const;
};

void doTooltip(string_t content, GfxPoint anchor);

#endif
